//+------------------------------------------------------------------+
//|                                       Advanced with Includes.mq4 |
//|                                                     Andrew Young |
//|                                   http://www.easyexpertforex.com |
//+------------------------------------------------------------------+

// Preprocessor
#property copyright "Andrew Young"
#include <IncludeExample.mqh>

extern string MMSettings = "--------- Money Management Settings ----------";
extern bool DynamicLotSize = true;
extern double EquityPercent = 2;
extern double FixedLotSize = 0.1;

extern double StopLoss = 50;
extern double TakeProfit = 100;

extern int TrailingStop = 50;
extern int MinimumProfit = 50;

extern int Slippage = 5;
extern int MagicNumber = 123;

extern bool CheckOncePerBar = true;

extern bool UseMartingale = false;
extern double Multiplier = 2;
extern double StartLot = 0.01;
extern int Levels = 10;

//--------------------------------------------------------------------------
//-------------------------- Indicator Settings ----------------------------
//--------------------------------------------------------------------------

extern string Null = "---------- Indicator Settings -------------------";
extern int       BoxLength                        = 21;
extern double    BoxRange                         = 28;
extern string    BoxTimeFrame                     = "0";
extern double    BoxBufferPips                    = 1;
extern int       MinBarsClosedOutsideBO           = 0;
extern int       MaxBreakoutTradesPerBox          = 4;
extern bool      InitialBreakoutDirectionOnly     = false;
extern bool      LongTrades                       = true;
extern bool      ShortTrades                      = true;
extern double    QuickTakeProfit                  = 20;
extern double    StopLossOverride                 = 0;
extern double    EmergencyStopLoss                = 100;
extern bool      BoxMartingale                    = true;
extern bool      AutoReduceBoxSize                = true;
extern int       DaysBack                         = 100;
extern bool      SignalMail                       = false;
extern bool      SignalAlert                      = false;
// cosmetics inputs
extern bool      ShowFibs                         = false;
extern string    FibSequence                      = "0.618,1.382,2.618,4.236,5.854,7.472,9.090,11.708,14.326";
extern int       FibsFontSize                     = 9;
extern color     FibsLinesColor                   = LightGray;
extern int       FibsLinesWidth                   = 1;
extern bool      ShowSwings                       = false;
extern int       SwingsFontSize                   = 9;
extern color     SwingsLinesColor                 = Wheat;
extern int       SwingsLinesWidth                 = 1;
extern int       BoxFontSize                      = 9;
extern color     BoxColor                         = 11184640;
extern color     ContBoxColor                     = DarkSlateGray;
extern bool      ContBoxFullColored               = true;
extern color     BoxBufferLinesColor              = 11184640;
extern int       BoxBufferLinesWidth              = 2;
extern color     ContBoxBufferLinesColor          = DarkSlateGray;
extern int       ContBoxBufferLinesWidth          = 1;
extern color     BreakoutPriceColor               = 11184640;
extern int       BreakoutPriceWidth               = 2;
extern color     ContBoxPriceColor                = DarkSlateGray;
extern int       ChartDisplay                     = 3;
extern int       DisplayPanelFontSize             = 11;
extern color     StatsColor                       = Black;
extern color     StatsBGColor                     = DarkSalmon;
extern color     PipsProfitColor                  = DarkGreen;
extern color     PipsLossColor                    = MediumVioletRed;
extern int       StatsCorner                      = 0;
extern bool      BoxVerticalLineDelimiter         = false;
extern color     BoxVerticalLineColor             = DarkSlateGray;
extern int       SwingLabelsFontSize              = 9;
extern color     SwingLabelsColor                 = Yellow;
extern int       BuySignalArrowCode               = 2;
extern color     BuySignalArrowColor              = 11193702;
extern int       BuySignalArrowWidth              = 3;
extern int       SellSignalArrowCode              = 2;
extern color     SellSignalArrowColor             = 5275647;
extern int       SellSignalArrowWidth             = 3;
extern string    Fonts                            = "Calibri";

//--------------------------------------------------------------------------------------
//-------------------------- End of Extern variables -----------------------------------
//--------------------------------------------------------------------------------------

// Global variables
int BuyTicket;
int SellTicket;

double UsePoint;
int UseSlippage;

datetime CurrentTimeStamp;

int init()
{
   	UsePoint = PipPoint(Symbol());
		UseSlippage = GetSlippage(Symbol(),Slippage);

}



// Start function
int start()
	{
		
		
		// Execute on bar open
		if(CheckOncePerBar == true)
			{
				int BarShift = 1;
				if(CurrentTimeStamp != Time[0]) 
					{
						CurrentTimeStamp = Time[0];
						bool NewBar = true;
					}
				else NewBar = false;
			}
		else 
			{
				NewBar = true;
				BarShift = 0;
			}

		
		int SellSignal = iCustom(NULL,0,"AuthorizedSSBODynamicBreakoutBoxFinalEdition", 
		      BoxLength,                       
            BoxRange, BoxTimeFrame,                     
            BoxBufferPips ,                  
            MinBarsClosedOutsideBO ,          
            MaxBreakoutTradesPerBox  ,       
            InitialBreakoutDirectionOnly  ,   
            LongTrades ,                      
            ShortTrades   ,                  
            QuickTakeProfit,                 
            StopLossOverride,                
            EmergencyStopLoss,               
            BoxMartingale     ,               
            AutoReduceBoxSize  ,              
            DaysBack            ,            
            SignalMail,                       
            SignalAlert,                     
            ShowFibs    ,                    
            FibSequence  ,                    
            FibsFontSize  ,                   
            FibsLinesColor ,                  
            FibsLinesWidth  ,                
            ShowSwings ,                     
            SwingsFontSize,                   
            SwingsLinesColor,               
            SwingsLinesWidth ,                
            BoxFontSize   ,                
            BoxColor   ,                     
            ContBoxColor    ,                
            ContBoxFullColored ,             
            BoxBufferLinesColor  ,            
            BoxBufferLinesWidth  ,           
            ContBoxBufferLinesColor ,         
            ContBoxBufferLinesWidth ,         
            BreakoutPriceColor      ,        
            BreakoutPriceWidth  ,             
            ContBoxPriceColor   ,             
            ChartDisplay ,                   
            DisplayPanelFontSize  ,           
            StatsColor   ,                    
            StatsBGColor ,                  
            PipsProfitColor ,                 
            PipsLossColor ,                  
            StatsCorner  ,                   
            BoxVerticalLineDelimiter,        
            BoxVerticalLineColor ,            
            SwingLabelsFontSize  ,           
            SwingLabelsColor  ,             
            BuySignalArrowCode ,            
            BuySignalArrowColor  ,            
            BuySignalArrowWidth   ,           
            SellSignalArrowCode  ,            
            SellSignalArrowColor  ,           
            SellSignalArrowWidth  ,          
            Fonts,7, BarShift);


		int BuySignal = iCustom(NULL,0,"AuthorizedSSBODynamicBreakoutBoxFinalEdition", 
		      BoxLength,                       
            BoxRange, BoxTimeFrame,                     
            BoxBufferPips ,                  
            MinBarsClosedOutsideBO ,          
            MaxBreakoutTradesPerBox  ,       
            InitialBreakoutDirectionOnly  ,   
            LongTrades ,                      
            ShortTrades   ,                  
            QuickTakeProfit,                 
            StopLossOverride,                
            EmergencyStopLoss,               
            BoxMartingale     ,               
            AutoReduceBoxSize  ,              
            DaysBack            ,            
            SignalMail,                       
            SignalAlert,                     
            ShowFibs    ,                    
            FibSequence  ,                    
            FibsFontSize  ,                   
            FibsLinesColor ,                  
            FibsLinesWidth  ,                
            ShowSwings ,                     
            SwingsFontSize,                   
            SwingsLinesColor,               
            SwingsLinesWidth ,                
            BoxFontSize   ,                
            BoxColor   ,                     
            ContBoxColor    ,                
            ContBoxFullColored ,             
            BoxBufferLinesColor  ,            
            BoxBufferLinesWidth  ,           
            ContBoxBufferLinesColor ,         
            ContBoxBufferLinesWidth ,         
            BreakoutPriceColor      ,        
            BreakoutPriceWidth  ,             
            ContBoxPriceColor   ,             
            ChartDisplay ,                   
            DisplayPanelFontSize  ,           
            StatsColor   ,                    
            StatsBGColor ,                  
            PipsProfitColor ,                 
            PipsLossColor ,                  
            StatsCorner  ,                   
            BoxVerticalLineDelimiter,        
            BoxVerticalLineColor ,            
            SwingLabelsFontSize  ,           
            SwingLabelsColor  ,             
            BuySignalArrowCode ,            
            BuySignalArrowColor  ,            
            BuySignalArrowWidth   ,           
            SellSignalArrowCode  ,            
            SellSignalArrowColor  ,           
            SellSignalArrowWidth  ,          
            Fonts,6, BarShift);
            
            
		// Calculate lot size
		double LotSize = CalcLotSize(DynamicLotSize,EquityPercent,StopLoss,FixedLotSize);
		LotSize = VerifyLotSize(LotSize);
		
		
		// Begin trade block
		if(NewBar == true)
			{   
		
				// Buy order 
				if(BuySignal == 1)
					{
						// Close sell orders
						if(SellMarketCount(Symbol(),MagicNumber) > 2)
							{ 
								CloseAllSellOrders(Symbol(),MagicNumber,Slippage);
							}
                  if(UseMartingale == false) {
						// Open buy order
						BuyTicket = OpenBuyOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
						
				      }
				      
				      if(UseMartingale == true) {
						// Open buy order
						BuyTicket = OpenBuyOrder(Symbol(),LotsOptimized(StartLot),UseSlippage,MagicNumber);				      
				      }  
				      
						// Order modification
						if(BuyTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
							{
								OrderSelect(BuyTicket,SELECT_BY_TICKET);
								double OpenPrice = OrderOpenPrice();
				
								// Calculate and verify stop loss and take profit
								double BuyStopLoss = CalcBuyStopLoss(Symbol(),StopLoss,OpenPrice);
								if(BuyStopLoss > 0) BuyStopLoss = AdjustBelowStopLevel(Symbol(),BuyStopLoss,5);
					
								double BuyTakeProfit = CalcBuyTakeProfit(Symbol(),TakeProfit,OpenPrice);
								if(BuyTakeProfit > 0) BuyTakeProfit = AdjustAboveStopLevel(Symbol(),BuyTakeProfit,5);
					
								// Add stop loss and take profit
								AddStopProfit(BuyTicket,BuyStopLoss,BuyTakeProfit);
							}  
					}
		
		
				// Sell Order 
				if(SellSignal == 1)
					{
						if(BuyMarketCount(Symbol(),MagicNumber) > 2)
							{ 
								CloseAllBuyOrders(Symbol(),MagicNumber,Slippage);
							}
                  if(UseMartingale == false) {
						SellTicket = OpenSellOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
				  
				     }
				     
				      if(UseMartingale == true) {
						// Open Sell order
						SellTicket = OpenSellOrder(Symbol(),LotsOptimized(StartLot),UseSlippage,MagicNumber);				      
				      }  
						if(SellTicket > 0 && (StopLoss > 0 || TakeProfit > 0)) 
							{
								OrderSelect(SellTicket,SELECT_BY_TICKET);
								OpenPrice = OrderOpenPrice();
					
								double SellStopLoss = CalcSellStopLoss(Symbol(),StopLoss,OpenPrice);
								if(SellStopLoss > 0) SellStopLoss = AdjustAboveStopLevel(Symbol(),SellStopLoss,5);
					
								double SellTakeProfit = CalcSellTakeProfit(Symbol(),TakeProfit,OpenPrice);
								if(SellTakeProfit > 0) SellTakeProfit = AdjustBelowStopLevel(Symbol(),SellTakeProfit,5);
					
								AddStopProfit(SellTicket,SellStopLoss,SellTakeProfit);
							}  
					}
				
			}  // End trade block 
			
			
		// Adjust trailing stops	
		if(BuyMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
			{
				BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
			}

		if(SellMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
			{
				SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
			}
			
			
		return(0);
	}
	
	
double LotsOptimized (double StartLot)
{
   double Mlot;
   int orders = OrdersHistoryTotal(); // histroy orders total
   int losses=0; //number of losses without a win

   //calculate number of losses orders without a break
   if(UseMartingale == true)
      {
      for(int i=orders-1;i>=0;i--)
         {
          if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) {
      
      Mlot = (Multiplier * losses) * StartLot;
      Mlot=NormalizeDouble(Mlot,1);
      
      }
 
   //---- return lot size
   return(Mlot);    
}

}

